## bear 3.0.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
cmake_policy(VERSION 3.12)

project(Bear
        VERSION 3.0.8
        DESCRIPTION "Bear is a tool to generate compilation database for clang tooling."
        LANGUAGES C CXX
        )

option(ENABLE_UNIT_TESTS "Build and run unit test for this project" ON)
option(ENABLE_FUNC_TESTS "Build and run functional test for this project" ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(default_build_type "Release")
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
            STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
            "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif ()

# Superbuild variables for sub projects
include(ExternalProject)
set_property(DIRECTORY PROPERTY EP_BASE ${CMAKE_BINARY_DIR}/subprojects)
set(STAGED_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/stage)
set(DEPENDENCIES_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/subprojects/Install)
if (NOT CMAKE_INSTALL_LIBEXECDIR)
    include(GNUInstallDirs)
endif ()

# Verify or install dependencies
add_subdirectory(third_party)

# Build the project itself
ExternalProject_Add(BearSource
        SOURCE_DIR
            "${CMAKE_CURRENT_SOURCE_DIR}/source"
        DEPENDS
            nlohmann_json_dependency fmt_dependency spdlog_dependency grpc_dependency
            googletest_dependency
        CMAKE_ARGS
            -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
            -DCMAKE_PROJECT_VERSION=${CMAKE_PROJECT_VERSION}
            -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}
            -DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}
            -DCMAKE_CXX_STANDARD_REQUIRED=${CMAKE_CXX_STANDARD_REQUIRED}
            -DCMAKE_CXX_EXTENSIONS=${CMAKE_CXX_EXTENSIONS}
            -DCMAKE_CXX_FLAGS:STRING=${CMAKE_CXX_FLAGS}
            -DCMAKE_CXX_COMPILER:STRING=${CMAKE_CXX_COMPILER}
            -DPKG_CONFIG_EXECUTABLE:PATH=${PKG_CONFIG_EXECUTABLE}
        CMAKE_CACHE_ARGS
            -DCMAKE_PREFIX_PATH:PATH=${CMAKE_PREFIX_PATH}
            -DCMAKE_INSTALL_PREFIX:PATH=${STAGED_INSTALL_PREFIX}
            -DCMAKE_INSTALL_LIBEXECDIR:PATH=${CMAKE_INSTALL_LIBEXECDIR}
            -DROOT_INSTALL_PREFIX:PATH=${CMAKE_INSTALL_PREFIX}
            -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
            -DENABLE_UNIT_TESTS:BOOL=${ENABLE_UNIT_TESTS}
        TEST_BEFORE_INSTALL
            1
        TEST_COMMAND
            ctest # or `ctest -T memcheck`
        )

# Run the functional tests
if (ENABLE_FUNC_TESTS)
    ExternalProject_Add(BearTest
            SOURCE_DIR
                "${CMAKE_CURRENT_SOURCE_DIR}/test"
            DEPENDS
                BearSource
            CMAKE_CACHE_ARGS
                -DSTAGED_INSTALL_PREFIX:PATH=${STAGED_INSTALL_PREFIX}
            TEST_BEFORE_INSTALL
                1
            INSTALL_COMMAND
                ""
            TEST_COMMAND
                ctest --verbose
            )
endif ()

# Install the project artifacts from the staged directory
include(GNUInstallDirs)
install(DIRECTORY
            ${STAGED_INSTALL_PREFIX}/
        DESTINATION
            .
        USE_SOURCE_PERMISSIONS
)
install(FILES
            COPYING README.md INSTALL.md CONTRIBUTING.md CODE_OF_CONDUCT.md
        DESTINATION
            ${CMAKE_INSTALL_DOCDIR}
)

# Set up package from this project
set(CPACK_PACKAGE_NAME "bear")
set(CPACK_PACKAGE_CONTACT "László Nagy")
set(CPACK_PACKAGE_VENDOR ${CPACK_PACKAGE_CONTACT})
set(CPACK_PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "BuildEAR")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(CPACK_RPM_PACKAGE_RELEASE "1%{?dist}")
set(CPACK_RPM_PACKAGE_LICENSE "GPLv3")
set(CPACK_RPM_PACKAGE_GROUP "Development/Tools")
set(CPACK_RPM_PACKAGE_URL "http://github.com/rizsotto/Bear")
set(CPACK_RPM_PACKAGE_DESCRIPTION "Bear is a tool to generate compilation database for clang tooling.")
set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION
        "${CMAKE_INSTALL_MANDIR}"
        "${CMAKE_INSTALL_MANDIR}/man1")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
include(CPack)

=== source/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
cmake_policy(VERSION 3.12)

project(BearSource
        VERSION ${CMAKE_PROJECT_VERSION}
        LANGUAGES C CXX
        )

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSPDLOG_NO_EXCEPTIONS")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGOOGLE_PROTOBUF_NO_RTTI")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")

if (ENABLE_UNIT_TESTS)
    find_program(MEMORYCHECK_COMMAND NAMES valgrind)
    set(MEMORYCHECK_COMMAND_OPTIONS "--trace-children=yes --leak-check=full")

    include(CTest)
    enable_testing()

    find_package(PkgConfig REQUIRED)
    pkg_check_modules(GTest REQUIRED IMPORTED_TARGET gtest gtest_main gmock)
endif ()

find_package(Threads REQUIRED)
find_package(nlohmann_json REQUIRED)
find_package(fmt REQUIRED)
find_package(spdlog REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(gRPC REQUIRED IMPORTED_TARGET protobuf grpc++)
pkg_check_modules(sqlite REQUIRED IMPORTED_TARGET sqlite3)

if (UNIX AND NOT APPLE)
    set(SUPPORT_PRELOAD 1)
endif()

include(CheckIncludeFile)
check_include_file(spawn.h HAVE_SPAWN_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(dlfcn.h HAVE_DLFCN_H)
check_include_file(errno.h HAVE_ERRNO_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(sys/utsname.h HAVE_SYS_UTSNAME_H)
check_include_file(sys/wait.h HAVE_SYS_WAIT_H)
check_include_file(gnu/lib-names.h HAVE_GNU_LIB_NAMES_H)
include(CheckSymbolExists)
set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS})
set(CMAKE_REQUIRED_FLAGS -D_GNU_SOURCE)
check_symbol_exists(_NSGetEnviron "crt_externs.h" HAVE_NSGETENVIRON)
check_symbol_exists(dlopen "dlfcn.h" HAVE_DLOPEN)
check_symbol_exists(dlsym "dlfcn.h" HAVE_DLSYM)
check_symbol_exists(dlerror "dlfcn.h" HAVE_DLERROR)
check_symbol_exists(dlclose "dlfcn.h" HAVE_DLCLOSE)
check_symbol_exists(RTLD_NEXT "dlfcn.h" HAVE_RTLD_NEXT)
check_symbol_exists(EACCES "errno.h" HAVE_EACCES)
check_symbol_exists(ENOENT "errno.h" HAVE_ENOENT)
check_symbol_exists(strerror_r "string.h" HAVE_STRERROR_R)
check_symbol_exists(environ "unistd.h" HAVE_ENVIRON)
check_symbol_exists(uname "sys/utsname.h" HAVE_UNAME)
check_symbol_exists(confstr "unistd.h" HAVE_CONFSTR)
check_symbol_exists(_CS_PATH "unistd.h" HAVE_CS_PATH)
check_symbol_exists(_CS_GNU_LIBC_VERSION "unistd.h" HAVE_CS_GNU_LIBC_VERSION)
check_symbol_exists(_CS_GNU_LIBPTHREAD_VERSION "unistd.h" HAVE_CS_GNU_LIBPTHREAD_VERSION)

include(GNUInstallDirs) # The directory names are used in the config file
configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(libresult)
add_subdirectory(libflags)
add_subdirectory(libshell)
add_subdirectory(libsys)
add_subdirectory(libmain)
add_subdirectory(intercept)
add_subdirectory(citnames)
add_subdirectory(bear)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
cmake_policy(VERSION 3.12)

project(BearTest LANGUAGES C)

set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS})
set(CMAKE_REQUIRED_FLAGS -D_GNU_SOURCE)
include(CheckIncludeFile)
check_include_file(spawn.h HAVE_SPAWN_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(sys/wait.h HAVE_SYS_WAIT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
include(CheckSymbolExists)
check_symbol_exists(execve "unistd.h" HAVE_EXECVE)
check_symbol_exists(execv "unistd.h" HAVE_EXECV)
check_symbol_exists(execvpe "unistd.h" HAVE_EXECVPE)
check_symbol_exists(execvp "unistd.h" HAVE_EXECVP)
check_symbol_exists(execvP "unistd.h" HAVE_EXECVP2)
check_symbol_exists(exect "unistd.h" HAVE_EXECT)
check_symbol_exists(execl "unistd.h" HAVE_EXECL)
check_symbol_exists(execlp "unistd.h" HAVE_EXECLP)
check_symbol_exists(execle "unistd.h" HAVE_EXECLE)
check_symbol_exists(execveat "unistd.h" HAVE_EXECVEAT)
check_symbol_exists(fexecve "unistd.h" HAVE_FEXECVE)
check_symbol_exists(posix_spawn "spawn.h" HAVE_POSIX_SPAWN)
check_symbol_exists(posix_spawnp "spawn.h" HAVE_POSIX_SPAWNP)
check_symbol_exists(popen "stdio.h" HAVE_POPEN)
check_symbol_exists(system "stdlib.h" HAVE_SYSTEM)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.in
    ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg
    @ONLY)

enable_testing()

message(STATUS "Looking for lit")
find_program(LIT_EXECUTABLE
        NAMES lit
        PATHS ENV LIT_PATH)

if (LIT_EXECUTABLE)
    message(STATUS "Looking for lit -- ${LIT_EXECUTABLE}")

    include(GNUInstallDirs)
    add_test(NAME bear::func_test
            COMMAND ${LIT_EXECUTABLE}
            -D_TEST_EXEC_ROOT=${CMAKE_CURRENT_BINARY_DIR}
            -D_BIN_BEAR=${STAGED_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/bear
            -D_BIN_CITNAMES=${STAGED_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/citnames
            -D_BIN_INTERCEPT=${STAGED_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/intercept
            -D_BIN_ER=${STAGED_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/wrapper
            -D_BIN_WRAPPER=${STAGED_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/wrapper.d
            -D_LIB_EXEC=${STAGED_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}exec${CMAKE_SHARED_LIBRARY_SUFFIX}
            -v
            ${CMAKE_CURRENT_BINARY_DIR})

    set_tests_properties(bear::func_test PROPERTIES
            TIMEOUT 90
            )
endif ()

=== third_party/CMakeLists.txt ===
add_subdirectory(nlohmann_json)
add_subdirectory(fmt)
add_subdirectory(spdlog)
add_subdirectory(grpc)
add_subdirectory(sqlite)

if (ENABLE_UNIT_TESTS)
    add_subdirectory(googletest)
else ()
    add_custom_target(googletest_dependency)
endif ()

=== source/bear/CMakeLists.txt ===
# Create an executable from the sub projects.
add_executable(bear
        main.cc
        )

target_include_directories(bear PRIVATE ../citnames/include)
target_include_directories(bear PRIVATE ../intercept/include)
target_link_libraries(bear main_a)
target_link_libraries(bear sys_a)
target_link_libraries(bear flags_a)
target_link_libraries(bear fmt::fmt)
target_link_libraries(bear spdlog::spdlog)

include(GNUInstallDirs)
install(TARGETS bear
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Markdown file is the source to the man file. Please modify that and generate
# the man file from it with pandoc.
#
#   $ pandoc -s -t man bear.1.md -o bear.1
#
# This is not automated, because pandoc has big dependencies on different OS
# distributions and packaging would require to install those. Which might be
# too much effort to generate a single text file.

install(FILES man/bear.1
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== source/citnames/CMakeLists.txt ===
# Create a static library, which is used for unit tests and the final shared library.
add_library(citnames_json_a OBJECT
        source/Configuration.cc
        source/Output.cc
        )

target_link_libraries(citnames_json_a PUBLIC result_a)
target_link_libraries(citnames_json_a PUBLIC shell_a)
target_link_libraries(citnames_json_a PUBLIC sys_a)
target_link_libraries(citnames_json_a PUBLIC fmt::fmt)
target_link_libraries(citnames_json_a PUBLIC spdlog::spdlog)
target_link_libraries(citnames_json_a PRIVATE nlohmann_json::nlohmann_json)
target_compile_options(citnames_json_a PRIVATE -fexceptions)

# Create a static library, which is used for unit tests and the final shared library.
add_library(citnames_a OBJECT
        source/Application.cc
        source/EventsDatabase.cc
        source/semantic/Parsers.cc
        source/semantic/Semantic.cc
        source/semantic/Tool.cc
        source/semantic/ToolClang.cc
        source/semantic/ToolCuda.cc
        source/semantic/ToolGcc.cc
        source/semantic/ToolWrapper.cc
        source/semantic/ToolExtendingWrapper.cc
        )

target_include_directories(citnames_a PUBLIC include/)
target_include_directories(citnames_a PUBLIC source/)
target_link_libraries(citnames_a PUBLIC main_a)
target_link_libraries(citnames_a PUBLIC domain_a)
target_link_libraries(citnames_a PUBLIC result_a)
target_link_libraries(citnames_a PUBLIC flags_a)
target_link_libraries(citnames_a PUBLIC rpc_a)
target_link_libraries(citnames_a PUBLIC sys_a)
target_link_libraries(citnames_a PUBLIC fmt::fmt)
target_link_libraries(citnames_a PUBLIC spdlog::spdlog)
target_link_libraries(citnames_a PUBLIC PkgConfig::sqlite)

# Create an executable from the sub projects.
add_executable(citnames
        main.cc
        )

target_link_libraries(citnames main_a)
target_link_libraries(citnames citnames_a)
target_link_libraries(citnames citnames_json_a)
target_link_libraries(citnames domain_a)
target_link_libraries(citnames result_a)
target_link_libraries(citnames rpc_a)
target_link_libraries(citnames flags_a)
target_link_libraries(citnames shell_a)
target_link_libraries(citnames sys_a)
target_link_libraries(citnames rpc_a)
target_link_libraries(citnames fmt::fmt)
target_link_libraries(citnames spdlog::spdlog)
target_link_libraries(citnames nlohmann_json::nlohmann_json)
target_link_libraries(citnames PkgConfig::sqlite)

include(GNUInstallDirs)
install(TARGETS citnames
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Markdown file is the source to the man file. Please modify that and generate
# the man file from it with pandoc.
#
#   $ pandoc -s -t man citnames.1.md -o citnames.1
#
# This is not automated, because pandoc has big dependencies on different OS
# distributions and packaging would require to install those. Which might be
# too much effort to generate a single text file.

install(FILES man/citnames.1
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

if (ENABLE_UNIT_TESTS)
    add_executable(citnames_unit_test
            test/OutputTest.cc
            test/ToolTest.cc
            test/ToolGccTest.cc
            )

    target_link_libraries(citnames_unit_test main_a)
    target_link_libraries(citnames_unit_test citnames_a)
    target_link_libraries(citnames_unit_test citnames_json_a)
    target_link_libraries(citnames_unit_test domain_a)
    target_link_libraries(citnames_unit_test result_a)
    target_link_libraries(citnames_unit_test rpc_a)
    target_link_libraries(citnames_unit_test flags_a)
    target_link_libraries(citnames_unit_test shell_a)
    target_link_libraries(citnames_unit_test sys_a)
    target_link_libraries(citnames_unit_test rpc_a)
    target_link_libraries(citnames_unit_test fmt::fmt)
    target_link_libraries(citnames_unit_test nlohmann_json::nlohmann_json)
    target_link_libraries(citnames_unit_test PkgConfig::sqlite)
    target_link_libraries(citnames_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::citnames_unit_test COMMAND $<TARGET_FILE:citnames_unit_test>)
endif ()

=== source/intercept/CMakeLists.txt ===
add_subdirectory(proto)

include(GNUInstallDirs)

add_library(domain_a OBJECT
        source/Domain.cc
        source/Convert.cc
        )

target_include_directories(domain_a PUBLIC source)
target_link_libraries(domain_a PUBLIC rpc_a)


# Create a static library, which is used for unit tests and the final shared library.
add_library(intercept_a OBJECT
        source/collect/Application.cc
        source/collect/EventsDatabase.cc
        source/collect/Reporter.cc
        source/collect/RpcServices.cc
        source/collect/Session.cc
        source/collect/SessionWrapper.cc
        )

if (SUPPORT_PRELOAD)
    target_sources(intercept_a PRIVATE source/collect/SessionLibrary.cc)
endif()

target_include_directories(intercept_a PUBLIC include/)
target_include_directories(intercept_a PUBLIC source/)
target_link_libraries(intercept_a PUBLIC domain_a)
target_link_libraries(intercept_a PUBLIC main_a)
target_link_libraries(intercept_a PUBLIC exec_a)
target_link_libraries(intercept_a PUBLIC flags_a)
target_link_libraries(intercept_a PUBLIC rpc_a)
target_link_libraries(intercept_a PUBLIC sys_a)
target_link_libraries(intercept_a PUBLIC result_a)
target_link_libraries(intercept_a PUBLIC spdlog::spdlog)
target_link_libraries(intercept_a PUBLIC PkgConfig::sqlite)

# Create an executable from the sub projects.
add_executable(intercept
        source/collect/main.cc
        )

target_link_libraries(intercept domain_a)
target_link_libraries(intercept main_a)
target_link_libraries(intercept intercept_a)
target_link_libraries(intercept rpc_a)
target_link_libraries(intercept sys_a)
target_link_libraries(intercept flags_a)
target_link_libraries(intercept exec_a)

install(TARGETS intercept
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Markdown file is the source to the man file. Please modify that and generate
# the man file from it with pandoc.
#
#   $ pandoc -s -t man intercept.1.md -o intercept.1
#
# This is not automated, because pandoc has big dependencies on different OS
# distributions and packaging would require to install those. Which might be
# too much effort to generate a single text file.

install(FILES man/intercept.1
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

add_executable(wrapper
        source/report/wrapper/EventFactory.cc
        source/report/wrapper/EventReporter.cc
        source/report/wrapper/RpcClients.cc
        source/report/wrapper/Application.cc
        source/report/wrapper/main.cc
        )

target_include_directories(wrapper PUBLIC source/)
target_link_libraries(wrapper domain_a)
target_link_libraries(wrapper main_a)
target_link_libraries(wrapper flags_a)
target_link_libraries(wrapper result_a)
target_link_libraries(wrapper sys_a)
target_link_libraries(wrapper rpc_a)
target_link_libraries(wrapper spdlog::spdlog)

install(TARGETS wrapper
        RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})
install(DIRECTORY
        DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/wrapper.d)
install(CODE "
    execute_process(
        COMMAND ln -sf ../wrapper ar
        COMMAND ln -sf ../wrapper as
        COMMAND ln -sf ../wrapper cc
        COMMAND ln -sf ../wrapper c++
        COMMAND ln -sf ../wrapper cpp
        COMMAND ln -sf ../wrapper gcc
        COMMAND ln -sf ../wrapper g++
        COMMAND ln -sf ../wrapper f77
        COMMAND ln -sf ../wrapper m2c
        COMMAND ln -sf ../wrapper pc
        COMMAND ln -sf ../wrapper lex
        COMMAND ln -sf ../wrapper flex
        COMMAND ln -sf ../wrapper yacc
        COMMAND ln -sf ../wrapper bison
        COMMAND ln -sf ../wrapper lint
        COMMAND ln -sf ../wrapper makeinfo
        COMMAND ln -sf ../wrapper tex
        COMMAND ln -sf ../wrapper tex2dvi
        COMMAND ln -sf ../wrapper weave
        COMMAND ln -sf ../wrapper cweave
        COMMAND ln -sf ../wrapper tangle
        COMMAND ln -sf ../wrapper ctangle
        COMMAND ln -sf ../wrapper nm
        COMMAND ln -sf ../wrapper ld
        COMMAND ln -sf ../wrapper strip
        COMMAND ln -sf ../wrapper objcopy
        COMMAND ln -sf ../wrapper objdump
        COMMAND ln -sf ../wrapper ranlib
        COMMAND ln -sf ../wrapper readelf
        WORKING_DIRECTORY ${DESTDIR}${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/wrapper.d
    )
")

add_library(exec_a OBJECT
        source/report/libexec/Buffer.cc
        source/report/libexec/Environment.cc
        source/report/libexec/Executor.cc
        source/report/libexec/Linker.cc
        source/report/libexec/Logger.cc
        source/report/libexec/Paths.cc
        source/report/libexec/Resolver.cc
        source/report/libexec/Session.cc
        )

target_include_directories(exec_a PUBLIC source)
target_link_libraries(exec_a PUBLIC result_a)
target_link_libraries(exec_a PUBLIC ${CMAKE_DL_LIBS})
set_target_properties(exec_a PROPERTIES
        LINKER_LANGUAGE "C"
        POSITION_INDEPENDENT_CODE 1)

# Create a shared library from the sub projects.
add_library(exec SHARED
        source/report/libexec/lib.cc
        source/report/libexec/std.cc
        )

target_link_libraries(exec exec_a)
if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set_target_properties(exec PROPERTIES
            LINKER_LANGUAGE "C"
            CMAKE_CXX_IMPLICIT_LINK_LIBRARIES ""
            LINK_FLAGS "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/libexec.version"
            )
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set_target_properties(exec PROPERTIES
            LINKER_LANGUAGE "C"
            OSX_ARCHITECTURES:STRING "i386;x86_64"
            MACOSX_RPATH:BOOL ON
            )
endif ()

install(TARGETS exec
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

# Create unit test.
if (ENABLE_UNIT_TESTS)
    add_executable(exec_unit_test
            test/libexec/ArrayTest.cc
            test/libexec/BufferTest.cc
            test/libexec/ExecutorTest.cc
            test/libexec/PathsTest.cc
            test/libexec/SessionTest.cc
            )

    target_include_directories(exec_unit_test PRIVATE test)
    target_link_libraries(exec_unit_test exec_a)
    target_link_libraries(exec_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::exec_unit_test COMMAND $<TARGET_FILE:exec_unit_test>)

    add_executable(intercept_unit_test
            test/SessionTest.cc
            )

    target_link_libraries(intercept_unit_test domain_a)
    target_link_libraries(intercept_unit_test main_a)
    target_link_libraries(intercept_unit_test exec_a)
    target_link_libraries(intercept_unit_test intercept_a)
    target_link_libraries(intercept_unit_test rpc_a)
    target_link_libraries(intercept_unit_test sys_a)
    target_link_libraries(intercept_unit_test flags_a)
    target_link_libraries(intercept_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::intercept_unit_test COMMAND $<TARGET_FILE:intercept_unit_test>)
endif ()

=== source/libflags/CMakeLists.txt ===
add_library(flags_a OBJECT
        source/Flags.cc
        )

target_include_directories(flags_a PUBLIC include/)
target_link_libraries(flags_a PUBLIC result_a)
target_link_libraries(flags_a PRIVATE fmt::fmt)

if (ENABLE_UNIT_TESTS)
    add_executable(flags_unit_test
            test/FlagsTest.cc
            )

    target_link_libraries(flags_unit_test result_a)
    target_link_libraries(flags_unit_test flags_a)
    target_link_libraries(flags_unit_test fmt::fmt)
    target_link_libraries(flags_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::flags_unit_test COMMAND $<TARGET_FILE:flags_unit_test>)
endif ()

=== source/libmain/CMakeLists.txt ===
add_library(main_a OBJECT
        source/ApplicationLogConfig.cc
        source/ApplicationFromArgs.cc
        )

target_include_directories(main_a PUBLIC include/)
target_link_libraries(main_a PUBLIC result_a)
target_link_libraries(main_a PUBLIC flags_a)
target_link_libraries(main_a PUBLIC fmt::fmt)
target_link_libraries(main_a PUBLIC spdlog::spdlog)

=== source/libresult/CMakeLists.txt ===
add_library(result_a INTERFACE
        )

target_include_directories(result_a INTERFACE include/)

if (ENABLE_UNIT_TESTS)
    add_executable(result_unit_test
            test/ResultTest.cc
            )

    target_link_libraries(result_unit_test result_a)
    target_link_libraries(result_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::result_unit_test COMMAND $<TARGET_FILE:result_unit_test>)
endif ()

=== source/libshell/CMakeLists.txt ===
add_library(shell_a OBJECT
        source/Command.cc
        )

target_include_directories(shell_a PUBLIC include/)
target_link_libraries(shell_a PUBLIC result_a)

if (ENABLE_UNIT_TESTS)
    add_executable(shell_unit_test
            test/CommandTest.cc
            )

    target_link_libraries(shell_unit_test shell_a)
    target_link_libraries(shell_unit_test result_a)
    target_link_libraries(shell_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::shell_unit_test COMMAND $<TARGET_FILE:shell_unit_test>)
endif ()

=== source/libsys/CMakeLists.txt ===
add_library(sys_a OBJECT
        source/Os.cc
        source/Guard.cc
        source/Errors.cc
        source/Path.cc
        source/Process.cc
        source/Signal.cc
        )

target_include_directories(sys_a PUBLIC include/)
target_link_libraries(sys_a PUBLIC ${CMAKE_DL_LIBS})
target_link_libraries(sys_a PUBLIC result_a)
target_link_libraries(sys_a PRIVATE fmt::fmt)
target_link_libraries(sys_a PRIVATE spdlog::spdlog)

if (ENABLE_UNIT_TESTS)
    add_executable(sys_unit_test
            test/EnvironmentTest.cc
            test/ErrorsTest.cc
            test/PathTest.cc
            )

    target_include_directories(sys_unit_test PRIVATE source/)
    target_link_libraries(sys_unit_test sys_a)
    target_link_libraries(sys_unit_test result_a)
    target_link_libraries(sys_unit_test fmt::fmt)
    target_link_libraries(sys_unit_test PkgConfig::GTest ${CMAKE_THREAD_LIBS_INIT})

    add_test(NAME bear::sys_unit_test COMMAND $<TARGET_FILE:sys_unit_test>)
endif ()

=== debian/changelog ===
bear (3.0.8-1) unstable; urgency=medium

  * New upstream release
  * debian/copyright: Bump copyright years

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 05 Feb 2021 22:33:05 +0100

bear (3.0.7-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Add B-D on libsqlite3-dev
  * debian/tests/control: Drop superficial restriction

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 14 Jan 2021 21:57:15 +0100

bear (3.0.6-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 02 Jan 2021 09:58:45 +0100

bear (3.0.5-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 28 Dec 2020 19:31:47 +0100

bear (3.0.4-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 14 Dec 2020 21:52:31 +0100

bear (3.0.3-1) unstable; urgency=medium

  * New upstream release
  * debian/tests: Fix smoke test

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 23 Nov 2020 22:37:28 +0100

bear (3.0.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Bump Standards-Version
  * debian/: Adapt to new upstream version

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 22 Nov 2020 23:29:03 +0100

bear (2.4.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/control: Bump debhelper compat to 13

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 13 Sep 2020 11:11:12 +0200

=== debian/control ===
Source: bear
Priority: optional
Section: devel
Maintainer: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libfmt-dev,
 libgmock-dev,
 libgrpc++-dev,
 libgtest-dev,
 libprotobuf-dev,
 libspdlog-dev,
 libsqlite3-dev,
 nlohmann-json3-dev,
 pkg-config,
 protobuf-compiler-grpc
Standards-Version: 4.5.1
Homepage: https://github.com/rizsotto/Bear
Vcs-Browser: https://salsa.debian.org/sramacher/bear
Vcs-Git: https://salsa.debian.org/sramacher/bear.git
Rules-Requires-Root: no

Package: bear
Architecture: any
Depends:
 libear (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: generate compilation database for Clang tooling
 Bear records the flags passed to the compiler for each translation unit and
 stores them in a JSON file. This file can be used by Clang's tooling interface
 and programs like clang-check to process a translation unit.
 .
 cmake supports the generation of JSON compilation databases out of the box.
 For any other build system that does not support this, Bear can be used
 instead to intercept the invocation of the compiler.

Package: libear
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: generate compilation database for Clang tooling (wrapper library)
 Bear records the flags passed to the compiler for each translation unit and
 stores them in a JSON file. This file can be used by Clang's tooling interface
 and programs like clang-check to process a translation unit.
 .
 cmake supports the generation of JSON compilation databases out of the box.
 For any other build system that does not support this, Bear can be used
 instead to intercept the invocation of the compiler.
 .
 This is the required library for wrapping system calls.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_LIBEXECDIR=lib/${DEB_HOST_MULTIARCH}/bear

override_dh_auto_test:
	# The tests fail if /usr/lib/ccache is in PATH so we remove it here. The tests
	# do not fail if CC or CXX are set to use ccache.
	PATH=$(shell echo $$PATH | \
		sed -e 's;:/usr/lib/ccache/\?;;' \
			-e 's;^/usr/lib/ccache/\?;;') \
		dh_auto_test

=== debian/tests/control ===
Tests: smoke
Depends: bear, build-essential, python3
Restrictions: allow-stderr
